/*
 * Keyboard module
 *
 * NB:  DO NOT IMPORT OR INCLUDE THIS FILE INTO YOUR PROGRAM.
 *      IT WILL BE IMPLICITLY IMPORTED.
 */

unit
module Keyboard
    export ~.*all

    % The actual codes returned by getch/getchar or the 
    % array index for Input.KeyDown
    const KEY_CTRL_A : char := chr (1)
    const KEY_CTRL_B : char := chr (2)
    const KEY_CTRL_C : char := chr (3)
    const KEY_CTRL_D : char := chr (4)
    const KEY_CTRL_E : char := chr (5)
    const KEY_CTRL_F : char := chr (6)
    const KEY_CTRL_G : char := chr (7)
    const KEY_CTRL_H : char := chr (8)
    const KEY_BACKSPACE : char := chr (8)
    const KEY_CTRL_I : char := chr (9)
    const KEY_TAB : char := chr (9)
    const KEY_CTRL_J : char := chr (10)
    const KEY_ENTER : char := chr (10)
    const KEY_CTRL_K : char := chr (11)
    const KEY_CTRL_L : char := chr (12)
    const KEY_CTRL_M : char := chr (13)
    const KEY_CTRL_N : char := chr (14)
    const KEY_CTRL_O : char := chr (15)
    const KEY_CTRL_P : char := chr (16)
    const KEY_CTRL_Q : char := chr (17)
    const KEY_CTRL_R : char := chr (18)
    const KEY_CTRL_S : char := chr (19)
    const KEY_CTRL_T : char := chr (20)
    const KEY_CTRL_U : char := chr (21)
    const KEY_CTRL_V : char := chr (22)
    const KEY_CTRL_W : char := chr (23)
    const KEY_CTRL_X : char := chr (24)
    const KEY_CTRL_Y : char := chr (25)
    const KEY_CTRL_Z : char := chr (26)
    const KEY_ESC : char := chr (27)
    const KEY_CTRL_OPEN_BRACKET : char := chr (27)
    const KEY_CTRL_BACKSLASH : char := chr (28)
    const KEY_CTRL_CLOSE_BRACKET : char := chr (29)
    const KEY_CTRL_CARET : char := chr (30)
    const KEY_CTRL_UNDERSCORE : char := chr (31)
    const KEY_CTRL_BACKSPACE : char := chr (127)
    const KEY_ALT_9 : char := chr (128)
    const KEY_ALT_0 : char := chr (129)
    const KEY_ALT_MINUS : char := chr (130)
    const KEY_ALT_EQUALS : char := chr (131)
    const KEY_CTRL_PGUP : char := chr (132)
    const KEY_F11 : char := chr (133)
    const KEY_F12 : char := chr (134)
    const KEY_SHIFT_F11 : char := chr (135)
    const KEY_SHIFT_F12 : char := chr (136)
    const KEY_CTRL_F11 : char := chr (137)
    const KEY_CTRL_F12 : char := chr (138)
    const KEY_ALT_F11 : char := chr (139)
    const KEY_ALT_F12 : char := chr (140)
    const KEY_CTRL_UP_ARROW : char := chr (141)
    const KEY_BACK_TAB : char := chr (143)
    const KEY_SHIFT_TAB : char := chr (143)
    const KEY_ALT_Q : char := chr (144)
    const KEY_ALT_W : char := chr (145)
    const KEY_CTRL_DOWN_ARROW : char := chr (145)
    const KEY_ALT_E : char := chr (146)
    const KEY_CTRL_INSERT : char := chr (146)
    const KEY_ALT_R : char := chr (147)
    const KEY_CTRL_DELETE : char := chr (147)
    const KEY_ALT_T : char := chr (148)
    const KEY_ALT_Y : char := chr (149)
    const KEY_ALT_U : char := chr (150)
    const KEY_ALT_I : char := chr (151)
    const KEY_ALT_O : char := chr (152)
    const KEY_ALT_P : char := chr (153)
    const KEY_ALT_A : char := chr (158)
    const KEY_ALT_S : char := chr (159)
    const KEY_ALT_D : char := chr (160)
    const KEY_ALT_F : char := chr (161)
    const KEY_ALT_G : char := chr (162)
    const KEY_ALT_H : char := chr (163)
    const KEY_ALT_J : char := chr (164)
    const KEY_ALT_K : char := chr (165)
    const KEY_ALT_L : char := chr (166)
    const KEY_ALT_Z : char := chr (172)
    const KEY_ALT_X : char := chr (173)
    const KEY_ALT_C : char := chr (174)
    const KEY_ALT_V : char := chr (175)
    const KEY_ALT_B : char := chr (176)
    const KEY_ALT_N : char := chr (177)
    const KEY_ALT_M : char := chr (178)
    const KEY_SHIFT : char := chr (180)
    const KEY_CTRL : char := chr (181)
    const KEY_ALT : char := chr (182)
    const KEY_KEYPAD_5 : char := chr (183)
    const KEY_F1 : char := chr (187)
    const KEY_F2 : char := chr (188)
    const KEY_F3 : char := chr (189)
    const KEY_F4 : char := chr (190)
    const KEY_F5 : char := chr (191)
    const KEY_F6 : char := chr (192)
    const KEY_F7 : char := chr (193)
    const KEY_F8 : char := chr (194)
    const KEY_F9 : char := chr (195)
    const KEY_F10 : char := chr (196)
    const KEY_HOME : char := chr (199)
    const KEY_UP_ARROW : char := chr (200)
    const KEY_PGUP : char := chr (201)
    const KEY_LEFT_ARROW : char := chr (203)
    const KEY_RIGHT_ARROW : char := chr (205)
    const KEY_END : char := chr (207)
    const KEY_DOWN_ARROW : char := chr (208)
    const KEY_PGDN : char := chr (209)
    const KEY_INSERT : char := chr (210)
    const KEY_DELETE : char := chr (211)
    const KEY_SHIFT_F1 : char := chr (212)
    const KEY_SHIFT_F2 : char := chr (213)
    const KEY_SHIFT_F3 : char := chr (214)
    const KEY_SHIFT_F4 : char := chr (215)
    const KEY_SHIFT_F5 : char := chr (216)
    const KEY_SHIFT_F6 : char := chr (217)
    const KEY_SHIFT_F7 : char := chr (218)
    const KEY_SHIFT_F8 : char := chr (219)
    const KEY_SHIFT_F9 : char := chr (220)
    const KEY_SHIFT_F10 : char := chr (221)
    const KEY_CTRL_F1 : char := chr (222)
    const KEY_CTRL_F2 : char := chr (223)
    const KEY_CTRL_F3 : char := chr (224)
    const KEY_CTRL_F4 : char := chr (225)
    const KEY_CTRL_F5 : char := chr (226)
    const KEY_CTRL_F6 : char := chr (227)
    const KEY_CTRL_F7 : char := chr (228)
    const KEY_CTRL_F8 : char := chr (229)
    const KEY_CTRL_F9 : char := chr (230)
    const KEY_CTRL_F10 : char := chr (231)
    const KEY_ALT_F1 : char := chr (232)
    const KEY_ALT_F2 : char := chr (233)
    const KEY_ALT_F3 : char := chr (234)
    const KEY_ALT_F4 : char := chr (235)
    const KEY_ALT_F5 : char := chr (236)
    const KEY_ALT_F6 : char := chr (237)
    const KEY_ALT_F7 : char := chr (238)
    const KEY_ALT_F8 : char := chr (239)
    const KEY_ALT_F9 : char := chr (240)
    const KEY_ALT_F10 : char := chr (241)
    const KEY_CTRL_LEFT_ARROW : char := chr (243)
    const KEY_CTRL_RIGHT_ARROW : char := chr (244)
    const KEY_CTRL_END : char := chr (245)
    const KEY_CTRL_PGDN : char := chr (246)
    const KEY_CTRL_HOME : char := chr (247)
    const KEY_ALT_1 : char := chr (248)
    const KEY_ALT_2 : char := chr (249)
    const KEY_ALT_3 : char := chr (250)
    const KEY_ALT_4 : char := chr (251)
    const KEY_ALT_5 : char := chr (252)
    const KEY_ALT_6 : char := chr (253)
    const KEY_ALT_7 : char := chr (254)
    const KEY_ALT_8 : char := chr (255)

    % The ord values 
    const ORD_CTRL_A : int := 1
    const ORD_CTRL_B : int := 2
    const ORD_CTRL_C : int := 3
    const ORD_CTRL_D : int := 4
    const ORD_CTRL_E : int := 5
    const ORD_CTRL_F : int := 6
    const ORD_CTRL_G : int := 7
    const ORD_CTRL_H : int := 8
    const ORD_BACKSPACE : int := 8
    const ORD_CTRL_I : int := 9
    const ORD_TAB : int := 9
    const ORD_CTRL_J : int := 10
    const ORD_ENTER : int := 10
    const ORD_CTRL_K : int := 11
    const ORD_CTRL_L : int := 12
    const ORD_CTRL_M : int := 13
    const ORD_CTRL_N : int := 14
    const ORD_CTRL_O : int := 15
    const ORD_CTRL_P : int := 16
    const ORD_CTRL_Q : int := 17
    const ORD_CTRL_R : int := 18
    const ORD_CTRL_S : int := 19
    const ORD_CTRL_T : int := 20
    const ORD_CTRL_U : int := 21
    const ORD_CTRL_V : int := 22
    const ORD_CTRL_W : int := 23
    const ORD_CTRL_X : int := 24
    const ORD_CTRL_Y : int := 25
    const ORD_CTRL_Z : int := 26
    const ORD_ESC : int := 27
    const ORD_CTRL_OPEN_BRACKET : int := 27
    const ORD_CTRL_BACKSLASH : int := 28
    const ORD_CTRL_CLOSE_BRACKET : int := 29
    const ORD_CTRL_CARET : int := 30
    const ORD_CTRL_UNDERSCORE : int := 31
    
    % Printables
    const ORD_SPACE : int := 32
    const ORD_EXCALAMATION_MARK : int := 33
    const ORD_QUOTATION_MARK : int := 34
    const ORD_HAS_MARK : int := 35
    const ORD_DOLLAR_SIGN : int := 36
    const ORD_PERCENT_SIGN : int := 37
    const ORD_AMPERSAND : int := 38
    const ORD_SINGLE_QUOTE : int := 39
    const ORD_OPEN_PARENTHESIS : int := 40
    const ORD_CLOSE_PARENTHESIS : int := 41
    const ORD_ASTERISK : int := 42
    const ORD_PLUS : int := 43
    const ORD_COMMA : int := 44
    const ORD_MINUS : int := 45
    const ORD_PERIOD : int := 46 
    const ORD_DOT : int := 46 
    const ORD_SLASH : int := 47
    const ORD_0 : int := 48
    const ORD_1 : int := 49
    const ORD_2 : int := 50
    const ORD_3 : int := 51
    const ORD_4 : int := 52
    const ORD_5 : int := 53
    const ORD_6 : int := 54
    const ORD_7 : int := 55
    const ORD_8 : int := 56
    const ORD_9 : int := 57
    const ORD_COLON : int := 58
    const ORD_SEMICOLON : int := 59
    const ORD_LESS_THAN : int := 60
    const ORD_EQUALS : int := 61
    const ORD_GREATER_THAN : int := 62
    const ORD_QUESTION_MARK : int := 63
    const ORD_AT_SIGN : int := 64 
    const ORD_A : int := 65
    const ORD_B : int := 66
    const ORD_C : int := 67
    const ORD_D : int := 68
    const ORD_E : int := 69
    const ORD_F : int := 70
    const ORD_G : int := 71
    const ORD_H : int := 72
    const ORD_I : int := 73
    const ORD_J : int := 74
    const ORD_K : int := 75
    const ORD_L : int := 76
    const ORD_M : int := 77
    const ORD_N : int := 78
    const ORD_O : int := 79
    const ORD_P : int := 80
    const ORD_Q : int := 81
    const ORD_R : int := 82
    const ORD_S : int := 83
    const ORD_T : int := 84
    const ORD_U : int := 85
    const ORD_V : int := 86
    const ORD_W : int := 87
    const ORD_X : int := 88
    const ORD_Y : int := 89
    const ORD_Z : int := 90
    const ORD_OPEN_BRACKET : int := 91
    const ORD_BACKSLASH : int := 92
    const ORD_CLOSE_BRACKET : int := 93
    const ORD_CARET : int := 94
    const ORD_UNDERSCORE : int := 95
    const ORD_APOSTROPHE : int := 96
    const ORD_LOWER_A : int := 97
    const ORD_LOWER_B : int := 98
    const ORD_LOWER_C : int := 99
    const ORD_LOWER_D : int := 100 
    const ORD_LOWER_E : int := 101 
    const ORD_LOWER_F : int := 102
    const ORD_LOWER_G : int := 103
    const ORD_LOWER_H : int := 104
    const ORD_LOWER_I : int := 105
    const ORD_LOWER_J : int := 106
    const ORD_LOWER_K : int := 107
    const ORD_LOWER_L : int := 108
    const ORD_LOWER_M : int := 109
    const ORD_LOWER_N : int := 110
    const ORD_LOWER_O : int := 111
    const ORD_LOWER_P : int := 112
    const ORD_LOWER_Q : int := 113
    const ORD_LOWER_R : int := 114
    const ORD_LOWER_S : int := 115
    const ORD_LOWER_T : int := 116
    const ORD_LOWER_U : int := 117
    const ORD_LOWER_V : int := 118
    const ORD_LOWER_W : int := 119
    const ORD_LOWER_X : int := 120
    const ORD_LOWER_Y : int := 121
    const ORD_LOWER_Z : int := 122
    const ORD_OPEN_BRACE : int := 123
    const ORD_BAR : int := 124
    const ORD_CLOSE_BRACE : int := 125
    const ORD_TILDE : int := 126

    % Const more special characters
    const ORD_CTRL_BACKSPACE : int := 127
    const ORD_ALT_9 : int := 128
    const ORD_ALT_0 : int := 129
    const ORD_ALT_MINUS : int := 130
    const ORD_ALT_EQUALS : int := 131
    const ORD_CTRL_PGUP : int := 132
    const ORD_F11 : int := 133
    const ORD_F12 : int := 134
    const ORD_SHIFT_F11 : int := 135
    const ORD_SHIFT_F12 : int := 136
    const ORD_CTRL_F11 : int := 137
    const ORD_CTRL_F12 : int := 138
    const ORD_ALT_F11 : int := 139
    const ORD_ALT_F12 : int := 140
    const ORD_CTRL_UP_ARROW : int := 141
    const ORD_BACK_TAB : int := 143
    const ORD_SHIFT_TAB : int := 143
    const ORD_ALT_Q : int := 144
    const ORD_ALT_W : int := 145
    const ORD_CTRL_DOWN_ARROW : int := 145
    const ORD_ALT_E : int := 145
    const ORD_CTRL_INSERT : int := 146
    const ORD_ALT_R : int := 145
    const ORD_CTRL_DELETE : int := 147
    const ORD_ALT_T : int := 148
    const ORD_ALT_Y : int := 149
    const ORD_ALT_U : int := 150
    const ORD_ALT_I : int := 151
    const ORD_ALT_O : int := 152
    const ORD_ALT_P : int := 153
    const ORD_ALT_A : int := 158
    const ORD_ALT_S : int := 159
    const ORD_ALT_D : int := 160
    const ORD_ALT_F : int := 161
    const ORD_ALT_G : int := 162
    const ORD_ALT_H : int := 163
    const ORD_ALT_J : int := 164
    const ORD_ALT_K : int := 165
    const ORD_ALT_L : int := 166
    const ORD_ALT_Z : int := 172
    const ORD_ALT_X : int := 173
    const ORD_ALT_C : int := 174
    const ORD_ALT_V : int := 175
    const ORD_ALT_B : int := 176
    const ORD_ALT_N : int := 177
    const ORD_ALT_M : int := 178
    const ORD_SHIFT : int := 180
    const ORD_CTRL : int := 181
    const ORD_ALT : int := 182
    const ORD_ORDPAD_5 : int := 183
    const ORD_F1 : int := 187
    const ORD_F2 : int := 188
    const ORD_F3 : int := 189
    const ORD_F4 : int := 190
    const ORD_F5 : int := 191
    const ORD_F6 : int := 192
    const ORD_F7 : int := 193
    const ORD_F8 : int := 194
    const ORD_F9 : int := 195
    const ORD_F10 : int := 196
    const ORD_HOME : int := 199
    const ORD_UP_ARROW : int := 200
    const ORD_PGUP : int := 201
    const ORD_LEFT_ARROW : int := 203
    const ORD_RIGHT_ARROW : int := 205
    const ORD_END : int := 207
    const ORD_DOWN_ARROW : int := 208
    const ORD_PGDN : int := 209
    const ORD_INSERT : int := 210
    const ORD_DELETE : int := 211
    const ORD_SHIFT_F1 : int := 212
    const ORD_SHIFT_F2 : int := 213
    const ORD_SHIFT_F3 : int := 214
    const ORD_SHIFT_F4 : int := 215
    const ORD_SHIFT_F5 : int := 216
    const ORD_SHIFT_F6 : int := 217
    const ORD_SHIFT_F7 : int := 218
    const ORD_SHIFT_F8 : int := 219
    const ORD_SHIFT_F9 : int := 220
    const ORD_SHIFT_F10 : int := 221
    const ORD_CTRL_F1 : int := 222
    const ORD_CTRL_F2 : int := 223
    const ORD_CTRL_F3 : int := 224
    const ORD_CTRL_F4 : int := 225
    const ORD_CTRL_F5 : int := 226
    const ORD_CTRL_F6 : int := 227
    const ORD_CTRL_F7 : int := 228
    const ORD_CTRL_F8 : int := 229
    const ORD_CTRL_F9 : int := 230
    const ORD_CTRL_F10 : int := 231
    const ORD_ALT_F1 : int := 232
    const ORD_ALT_F2 : int := 233
    const ORD_ALT_F3 : int := 234
    const ORD_ALT_F4 : int := 235
    const ORD_ALT_F5 : int := 236
    const ORD_ALT_F6 : int := 237
    const ORD_ALT_F7 : int := 238
    const ORD_ALT_F8 : int := 239
    const ORD_ALT_F9 : int := 240
    const ORD_ALT_F10 : int := 241
    const ORD_CTRL_LEFT_ARROW : int := 243
    const ORD_CTRL_RIGHT_ARROW : int := 244
    const ORD_CTRL_END : int := 245
    const ORD_CTRL_PGDN : int := 246
    const ORD_CTRL_HOME : int := 247
    const ORD_ALT_1 : int := 248
    const ORD_ALT_2 : int := 249
    const ORD_ALT_3 : int := 250
    const ORD_ALT_4 : int := 251
    const ORD_ALT_5 : int := 252
    const ORD_ALT_6 : int := 253
    const ORD_ALT_7 : int := 254
    const ORD_ALT_8 : int := 255
end Keyboard
